package io.agora.signal;

import org.junit.Test;

import java.util.concurrent.CountDownLatch;
import java.util.concurrent.TimeUnit;

import static org.junit.Assert.assertEquals;
import static org.junit.Assert.assertFalse;

/**
 * Created by aa on 13/4/2017.
 */
public class SignalTestPing {
    public static final String appid = "place appid to here";

    String user1 = "test_login_user1";

    public static void wait_time(CountDownLatch x, int tInMS){
        try {
            x.await(tInMS, TimeUnit.MILLISECONDS);
        } catch (InterruptedException e) {
        }
        assertEquals(x.getCount(), 0);
    }

    public static void sleep(int tInMS) {
        try {
            Thread.sleep(tInMS);
        } catch (InterruptedException e) {
        }
    }

    /**
     * test :
     *      API login
     *      API logout
     *          onLoginSuccess
     *          onLogout
     */
    @Test
    public void testLogin(){
        final CountDownLatch loginLatch = new CountDownLatch(1);
        final CountDownLatch logoutLatch = new CountDownLatch(1);

        Signal sig = new Signal(appid);
        sig.setDoLog(true);

        Signal.LoginSession session = sig.login(user1, "_no_need_token", new Signal.LoginCallback() {
            @Override
            public void onLoginSuccess(final Signal.LoginSession session, int uid) {
                loginLatch.countDown();
            }

            @Override
            public void onLogout(Signal.LoginSession session, int ecode) {
                logoutLatch.countDown();
                assertEquals(ecode, Signal.LOGOUT_E_USER);
            }
        });

        wait_time(loginLatch, 5000);

        sleep(1000 * 60);
        session.logout();

        wait_time(logoutLatch, 5000);
    }

}
