


//
//  ViewController.m
//  iosapp1
//
//  Created by vv on 18/6/15.
//  Copyright (c) 2015 Agora. All rights reserved.
//

#import "ViewController.h"

#import "agorasdk.h"
#import "AgoraRtcEngineKit.h"

#import <CommonCrypto/CommonDigest.h>

#define appID @""
#define certificate1 @""

@interface ViewController ()

@property (weak) IBOutlet NSTextField *logText;

@property (weak) IBOutlet NSButton *btnLogin;
@property (weak) IBOutlet NSButton *btnCallUser;
@property (weak) IBOutlet NSButton *btnJoin;
@property (weak) IBOutlet NSButton *btnSwitch;
@property (weak) IBOutlet NSButton *btnMsg;
@property (weak) IBOutlet NSTextField *txtAccount1;
@property (weak) IBOutlet NSTextField *txtAccount2;
@property (weak) IBOutlet NSTextField *txtChannel;


@end

@implementation ViewController{
    NSMutableString * logString;
    //    NSString *call_channel;
    BOOL isLogin;
    BOOL isJoined;
    BOOL isInCall;
    int msg_count;
    unsigned my_uid;
    
    AgoraAPI* inst;
    AgoraRtcEngineKit * instMedia;
}

- (NSString*)MD5:(NSString*)s
{
    // Create pointer to the string as UTF8
    const char *ptr = [s UTF8String];
    
    // Create byte array of unsigned chars
    unsigned char md5Buffer[CC_MD5_DIGEST_LENGTH];
    
    // Create 16 byte MD5 hash value, store in buffer
    CC_MD5(ptr, (CC_LONG)strlen(ptr), md5Buffer);
    
    // Convert MD5 value in the buffer to NSString of hex values
    NSMutableString *output = [NSMutableString stringWithCapacity:CC_MD5_DIGEST_LENGTH * 2];
    for(int i = 0; i < CC_MD5_DIGEST_LENGTH; i++)
        [output appendFormat:@"%02x",md5Buffer[i]];
    
    return output;
}

- (NSString *) calcToken:(NSString *)_appID certificate:(NSString *)certificate account:(NSString*)account expiredTime:(unsigned)expiredTime {
    // Token = 1:appID:expiredTime:sign
    // Token = 1:appID:expiredTime:md5(account + vendorID + certificate + expiredTime)
    
    NSString * sign = [self MD5:[NSString stringWithFormat:@"%@%@%@%d", account, _appID, certificate, expiredTime]];
    return [NSString stringWithFormat:@"1:%@:%d:%@", _appID, expiredTime, sign];
}

- (void)viewDidLoad {
    [super viewDidLoad];
    
    isLogin = false;
    isJoined = false;
    msg_count = 1;
    isInCall = false;
    
    inst =  [AgoraAPI getInstanceWithoutMedia:appID];
    instMedia = [AgoraRtcEngineKit sharedEngineWithAppId:appID delegate:nil];
    
    [instMedia setParameters:@"{\"rtc.log_filter\":32783}"];
    
    
    ViewController * __weak weak_self = self;
    AgoraAPI * __weak weak_inst = inst;
    
    inst.onLoginSuccess = ^(uint32_t uid, int fd){
        my_uid = uid;
        [weak_self log:[NSString stringWithFormat:
                   @"Login successfully "
                   ]];
        //        [inst joinChannel:@"channelName1"];
    };
    
    inst.onLogout = ^(AgoraEcode e){
        if (e == AgoraEcode_LOGOUT_E_USER){
            [weak_self log:[NSString stringWithFormat:
                       @"Logout successfully "
                       ]];
        }else{
            [weak_self log:[NSString stringWithFormat:
                       @"Logout on %lu",
                       (unsigned long)e
                       ]];
        }
        
        [weak_self set_state_logout];
        [weak_self set_state_not_in_call];
        [weak_self doLeave];
    };
    
    inst.onLoginFailed = ^(AgoraEcode e){
        [weak_self log:[NSString stringWithFormat:
                   @"Login failed %lu ", (unsigned long)e
                   ]];
        [weak_self set_state_logout];
        [weak_self set_state_not_in_call];
    };
    
    inst.onChannelJoined = ^(NSString* name){
        [weak_self log:[NSString stringWithFormat:
                   @"Join channel %@ successfully", name
                   ]];
    };
    
    inst.onChannelLeaved = ^(NSString* name, AgoraEcode ecode){
        if (ecode == AgoraEcode_LEAVECHANNEL_E_BYUSER){
            [weak_self log:[NSString stringWithFormat:
                       @"Leave channel %@ successfully", name
                       ]];
        }else{
            [weak_self log:[NSString stringWithFormat:
                       @"Leave channel %@ on %lu ",  name, (unsigned long)ecode
                       ]];
        }
    };
    
    inst.onInviteReceived = ^(NSString* channel, NSString *name, uint32_t uid, NSString *extra){
        [weak_self.txtChannel setStringValue:channel];
        
        [weak_self log:[NSString stringWithFormat:
                   @"onInviteReceived to %@ from %@:%u extra:%@", channel, name, uid, extra
                   ]];
        
        [weak_self log:[NSString stringWithFormat:
                   @"channelInviteAccept %@ from %@:%u", channel, name, uid
                   ]];
        
        [weak_self set_state_in_call];
        [weak_self doJoin];
        [weak_inst channelInviteAccept:channel account:name uid:uid];
    };
    
    inst.onInviteReceivedByPeer = ^(NSString* channel, NSString *name, uint32_t uid){
        [weak_self log:[NSString stringWithFormat:
                   @"onInviteReceivedByPeer to %@ from %@:%u", channel, name, uid
                   ]];
    };
    
    inst.onInviteAcceptedByPeer = ^(NSString* channel, NSString *name, uint32_t uid, NSString *extra){
        [weak_self log:[NSString stringWithFormat:
                   @"onInviteAcceptedByPeer to %@ from %@:%u", channel, name, uid
                   ]];
    };
    
    inst.onInviteEndByPeer = ^(NSString* channel, NSString *name, uint32_t uid, NSString *extra){
        [weak_self log:[NSString stringWithFormat:
                   @"onInviteEndByPeer to %@ from %@:%u", channel, name, uid
                   ]];
        
        [weak_self set_state_not_in_call];
        [weak_self doLeave];
    };
    
    inst.onInviteEndByMyself = ^(NSString* channel, NSString *name, uint32_t uid){
        [weak_self log:[NSString stringWithFormat:
                   @"onInviteEndByMyself to %@ from %@:%u", channel, name, uid
                   ]];
    };
    
    inst.onInviteFailed = ^(NSString* channelID,NSString* account,uint32_t uid,AgoraEcode ecode, NSString *extra){
        
        [weak_self log:[NSString stringWithFormat:
                   @"Call %@ failed, ecode = %lu", account, (unsigned long)ecode
                   ]];
        
        
        [weak_self set_state_not_in_call];
        [weak_self doLeave];
    };
    
    inst.onChannelUserLeaved = ^(NSString *name, uint32_t uid){
        [weak_self log:[NSString stringWithFormat:
                   @"onChannelUserLeaved %@:%u", name, uid
                   ]];
    };
    
    inst.onMessageChannelReceive = ^(NSString* channelID,NSString* account,uint32_t uid,NSString* msg) {
        [weak_self log:[NSString stringWithFormat:
                   @"Recv channel msg from %@ : %@ ", account, msg
                   ]];
    };
    
    
    inst.onLog = ^(NSString *txt){
        NSLog(@"%@", txt);
    };
    
    //    [inst dbg:@"lbss" b:@"lbs.d.agorabeckon.com"];
}

- (IBAction)onLogin:(id)sender {
    
    if (isLogin){
        [self set_state_logout];
        
        // logout
        [self log:[NSString stringWithFormat:
                   @"Logout"
                   ]];
        
        [inst logout];
        
    }else{
        [self set_state_login];
        
        NSString *name = self.txtAccount1.stringValue;
        uint32_t uid = 0;
        
        [self log:[NSString stringWithFormat:
                   @"Login as %@", name
                   ]];
        
        unsigned expiredTime =  (unsigned)[[NSDate date] timeIntervalSince1970] + 3600;
        
        [inst login:appID
            account:name
              token:[self calcToken:appID certificate:certificate1 account:name expiredTime:expiredTime]
                uid:uid
           deviceID:@""];
        
    }
}



- (IBAction)onSpeakerChange:(id)sender {
//    UISwitch *switchButton = (UISwitch*)sender;
//    [instMedia setEnableSpeakerphone:[switchButton isOn]];
};


- (IBAction)onBtnSwitch:(id)sender {
    NSString *name = self.txtAccount1.stringValue;
    [self.txtAccount1 setStringValue:[self.txtAccount2 stringValue]];
    [self.txtAccount2 setStringValue:name];
};


- (IBAction)onBtnMsg:(id)sender {
    if (isJoined){
        
        NSString * channelName = [self.txtChannel stringValue];
        
        NSString * msg = [NSString stringWithFormat:
                          @"msg %d from %@", msg_count++, [self.txtAccount1 stringValue]
                          ];
        [inst messageChannelSend:channelName msg:msg msgID:@""];
    }
};

- (IBAction)onBtnJoin:(id)sender {
    
    if (!isLogin) return;
    
    if (isJoined){
        [self doLeave];
    }else{
        [self doJoin];
    }
    
}

- (IBAction)onBtnCall:(id)sender {
    
    if (!isLogin) return;
    
    
    NSString *name = [self.txtAccount2 stringValue];
    uint32_t uid = 0;
    
    NSString * channelName = [self.txtChannel stringValue];
    
    if (isInCall){
        [self log:[NSString stringWithFormat:
                   @"End call %@ to %@", name, channelName
                   ]];
        
        [self set_state_not_in_call];
        [self doLeave];
        [inst channelInviteEnd:channelName account:name uid:uid];
        
        
    }else{
        [self log:[NSString stringWithFormat:
                   @"Invite %@:%u to %@", name, uid, channelName
                   ]];
        
        [self set_state_in_call];
        [self doJoin];
        [inst channelInviteUser:channelName account:name uid:uid];
        
    }
}

- (void) doJoin
{
    dispatch_async(dispatch_get_main_queue(), ^(){
        isJoined = true;
        [self.btnJoin setTitle:@"Leave"];
        
        [self log:[NSString stringWithFormat:
                   @"Join channel %@", [self.txtChannel stringValue]
                   ]];
        
        [inst channelJoin:[self.txtChannel stringValue]];
        [instMedia joinChannelByKey:appID channelName:[self.txtChannel stringValue] info:nil uid:my_uid joinSuccess:nil];
    });
}

- (void) doLeave
{
    dispatch_async(dispatch_get_main_queue(), ^(){
        isJoined = false;
        [self.btnJoin setTitle:@"Join"];
        [self log:[NSString stringWithFormat:
                   @"Leave channel %@", [self.txtChannel stringValue]
                   ]];
        
        [inst channelLeave:[self.txtChannel stringValue]];
        [instMedia leaveChannel:nil];
    });
}


- (void)set_state_logout{
    isLogin = false;
    dispatch_async(dispatch_get_main_queue(), ^(){
        [self.btnLogin setTitle:@"Login"];
    });
}

- (void)set_state_login{
    isLogin = true;
    dispatch_async(dispatch_get_main_queue(), ^(){
        [self.btnLogin setTitle:@"Logout"];
    });
}



- (void)set_state_in_call{
    isInCall = true;
    dispatch_async(dispatch_get_main_queue(), ^(){
        [self.btnCallUser setTitle:@"Bye" ];
    });
}

- (void)set_state_not_in_call{
    isInCall = false;
    dispatch_async(dispatch_get_main_queue(), ^(){
        [self.btnCallUser setTitle:@"Call"];
    });
}

//
//- (void)didReceiveMemoryWarning {
//    [super didReceiveMemoryWarning];
//    // Dispose of any resources that can be recreated.
//}

- (void) log : (NSString *)txt{
    [self performSelectorOnMainThread:@selector(appendLogString:) withObject:txt waitUntilDone:YES];
    //    [self performSelectorOnMainThread:@selector(appendLogString:) withObject:txt];
    //    [self appendLogString:txt];
    NSLog(@"%@", txt);
}

- (NSMutableString *)logString
{
    if (!logString) {
        logString = [[NSMutableString alloc] init];
    }
    return logString;
}

- (void)appendLogString:(NSString *)tt
{
    [self.logString appendFormat:@"%@\n", tt];
    
    [self.logText setStringValue:self.logString];
//    [self.logText scrollRangeToVisible:NSMakeRange(self.logString.length, 0)];
}


- (void)setRepresentedObject:(id)representedObject {
    [super setRepresentedObject:representedObject];
    
    // Update the view, if already loaded.
}

@end
